<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%">
      <v-toolbar style="position:relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-file-outline</v-icon
            ><b>Questão: {{ question.title }}</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon
              v-on="on"
              style="position:absolute; right: 15px"
              color="red"
              @click="handleClose"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>

      <!-- Questão -->
      <v-card-text class="px-8 pt-6 pb-6">
        <section style="color:#424242; margin-left: 1rem;">
          <!-- Enunciado -->
          <p style="font-size: 1rem">
            <b> (Questão) {{ question.body }} </b>
          </p>
          <!-- CADA TIPO DE QUESTAO TEM SEU LAYOUT -->
          <!-- OBJETIVA, MULTIPLA ESCOLHA -->
          <span
            v-if="question.questionType == 'objective' || question.questionType == 'multipleChoice'"
          >
            <span class="ml-2" v-for="(incorrect, index) in question.incorrectAnswers" :key="index">
              {{ orderQuestion[index] }} {{ incorrect.text }}
              <v-icon small color="red">mdi-close</v-icon>
              <br />
            </span>
            <span
              class="ml-2"
              v-for="(correct, index2) in question.correctAnswers"
              :key="`${index2}a`"
              style="font-weight: 500"
            >
              {{ orderQuestion[question.incorrectAnswers.length + index2] }}
              {{ correct.text }} <v-icon small color="green">mdi-check</v-icon>
              <br />
            </span>
          </span>
          <!-- Verdadeiro ou Falso -->
          <span v-if="question.questionType == 'trueOrFalse'">
            <span class="ml-2" v-for="(incorrect, index) in question.incorrectAnswers" :key="index">
              Incorreta - {{ incorrect.text }}
              <v-icon small color="red">mdi-close</v-icon>
              <br />
            </span>
            <span
              class="ml-2"
              v-for="(correct, index2) in question.correctAnswers"
              :key="`${index2}a`"
              style="font-weight: 500"
            >
              Correta -
              {{ correct.text }} <v-icon small color="green">mdi-check</v-icon>
              <br />
            </span>
          </span>
          <!-- Dissertativo -->
          <span v-if="question.questionType == 'dissertation'">
            Respostas esperadas:<br /><br />
            <span
              class="ml-2"
              v-for="(correct, index) in question.correctAnswers"
              :key="`${index}a`"
              style="font-weight: 500"
            >
              {{ correct.text }} <v-icon small color="green">mdi-check</v-icon>
              <br />
            </span>
          </span>
          <!-- SOMATÓRIO -->
          <span v-if="question.questionType == 'summation'">
            <span
              class="ml-2"
              v-for="(answer, index) in joinAlternatives(
                question.correctAnswers,
                question.incorrectAnswers
              )"
              :key="index"
            >
              <span :style="answer.correct && 'font-weight:600'">
                {{ Math.pow(2, index) > 10 ? `${Math.pow(2, index)}.` : `0${Math.pow(2, index)}.` }}
                {{ answer.text }}
              </span>
              <v-icon v-if="!answer.correct" small color="red">mdi-close</v-icon>
              <v-icon v-else small color="green">mdi-check</v-icon>
              <br />
            </span>
            <br /><b>Resposta:</b>
            {{ answerSum(question.correctAnswers, question.incorrectAnswers) }}
          </span>
        </section>
      </v-card-text>
      <v-divider class="mb-1 mx-8" />
      <!-- DADOS extras e do autor -->
      <v-card-text class="px-8 pt-6 pb-6">
        <section style="color:#424242; margin-left: 1rem;">
          <b>Área:</b>
          <span v-for="(area, index) in question.area" :key="index">
            {{ showAreaName(area) }}
            <span v-if="index != question.area.length - 1">/</span>
          </span>
          <br />
          <b>Tipo:</b> {{ showQuestionType(question.questionType) }}<br />
          <b>Dificuldade:</b> {{ showDifficultyType(question.difficulty) }}<br />
          <b>Visibilidade:</b> {{ showVisibilityType(question.visibility) }}<br />
          <b>Autor:</b>
          <span v-if="question.author">
            {{ question.author.name }} {{ question.author.surname }}
          </span>
          <span v-else> {{ userInfo.name }} {{ userInfo.surname }} </span>
          <br />
        </section>
      </v-card-text>
      <!-- Botão Fechar -->
      <v-card-actions class="mt-n3 pb-6 pr-6">
        <v-spacer />
        <v-btn color="lighter" text @click="handleClose">Fechar</v-btn>
      </v-card-actions>
    </v-card>
  </v-row>
</template>

<script>
export default {
  name: 'ReadQuestion',
  props: {
    question: { type: Object, default: {} },
    areas: {
      type: Array,
      default: () => {
        return []
      },
    },
  },
  data: () => ({
    orderQuestion: ['a)', 'b)', 'c)', 'd)', 'e)', 'f)', 'g)', 'h)', 'i)', 'j)', 'k)', 'l)'],
    userInfo: {},
  }),
  async created() {
    this.userInfo = await this.$getItem('userEHQ')
  },
  methods: {
    handleClose() {
      this.$emit('handleClose')
    },
    showQuestionType(type) {
      if (type == 'objective') return 'Multipla Escolha'
      if (type == 'summation') return 'Somatório'
      if (type == 'multipleChoice') return 'Multipla Escolha Multi-Resposta'
      if (type == 'trueOrFalse') return 'Verdadeiro ou Falso'
      if (type == 'dissertation') return 'Dissertativa'
    },
    showDifficultyType(item) {
      if (item == 'easy') return 'Fácil'
      if (item == 'medium') return 'Médio'
      if (item == 'hard') return 'Difícil'
    },
    showVisibilityType(item) {
      if (item == 'public') return 'Público'
      if (item == 'private') return 'Privado'
    },
    showAreaName(id) {
      for (let i = 0; i < this.areas.length; i++) {
        if (this.areas[i].id == id) return this.areas[i].name
      }
      return 'Category not found'
    },

    //apenas para o método summation
    joinAlternatives(arrayCorrect, arrayIncorrect) {
      arrayCorrect.forEach((item) => {
        item.correct = true
      })

      arrayIncorrect.forEach((item) => {
        item.correct = false
      })

      let newArray = arrayCorrect.concat(arrayIncorrect).sort((a, b) => {
        return a.order > b.order ? 1 : b.order > a.order ? -1 : 0
      })
      return newArray
    },

    answerSum(arrayCorrect, arrayIncorrect) {
      arrayCorrect.forEach((item) => {
        item.correct = true
      })

      arrayIncorrect.forEach((item) => {
        item.correct = false
      })
      let sum = 0
      let newArray = arrayCorrect.concat(arrayIncorrect)

      newArray.forEach((answer) => {
        if (answer.correct) {
          sum += Math.pow(2, answer.order)
        }
      })
      return sum
    },
  },
}
</script>

<style></style>
